/* $Id: driver.h,v 1.3 2005/04/30 15:09:38 dijkstra Exp $ */

/*
 * Copyright (c) 2005 Willem Dijkstra
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *    - Redistributions of source code must retain the above copyright
 *      notice, this list of conditions and the following disclaimer.
 *    - Redistributions in binary form must reproduce the above
 *      copyright notice, this list of conditions and the following
 *      disclaimer in the documentation and/or other materials provided
 *      with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT HOLDERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 */

#ifndef _SLDRIVER_H
#define _SLDRIVER_H

/* driver capabilities */
#define DC_BACKLIGHT    0x0001
#define DC_BLOCK        0x0002
#define DC_CONTRAST     0x0004
#define DC_HBAR         0x0008
#define DC_VBAR         0x0010

/* Drivers will set LCD_X and LCD_Y */
#if defined (CF632) || defined (CF634) || defined (CF634USB)
#include "driver_cf.h"
#endif

#if defined (HD44780)
#include "driver_hd44780.h"
#endif

#if defined TEST
#include "driver_test.h"
#endif

struct specialchar {
    unsigned long line[8];
};

__BEGIN_DECLS
int driver_capabilities;
char *driver_name;
void driver_connect(char *, int);
char driver_get_hchar(int);
char driver_get_vchar(int);
void driver_nprintf(int, char *, ...);
void driver_printf(char *, ...);
void driver_reset();
void driver_set_backlight(int);
void driver_set_contrast(int);
void driver_set_specialchar(int, struct specialchar *);
void driver_set_xy(int, int);
__END_DECLS

#endif
